import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { IDataSourceDataProvider } from "./IDataSourceDataProvider";
import { IDataSourceVirtualDataProvider } from "./IDataSourceVirtualDataProvider";
import { IExternalVirtualDataSource } from "./IExternalVirtualDataSource";
import { Type } from "./type";
import { ISummaryResult } from "./ISummaryResult";
import { DataSourceRowType } from "./DataSourceRowType";
import { DataSourcePageRequestPriority } from "./DataSourcePageRequestPriority";
/**
 * @hidden
 */
export declare class VirtualDataSource extends BaseDataSource implements IPageCandidatesSink {
    static $t: Type;
    constructor();
    private cb;
    private cs;
    private de;
    protected cm: PagePredictionEngine;
    protected get_actualBaseDataProvider(): IDataSourceDataProvider;
    protected readonly actualBaseDataProvider: IDataSourceDataProvider;
    private cf;
    dataProvider: IDataSourceVirtualDataProvider;
    private ce;
    actualDataProvider: IDataSourceVirtualDataProvider;
    private dd;
    pageSizeRequested: number;
    protected resetCache(): void;
    protected resetCacheOverride(): void;
    private dc;
    maxCachedPages: number;
    protected actualPageSizePopulated: boolean;
    private cy;
    actualPageSize: number;
    private cq;
    protected get_isSortingSupported(): boolean;
    protected get_isFilteringSupported(): boolean;
    protected get_isGroupingSupported(): boolean;
    private cj;
    ck: IExternalVirtualDataSource;
    protected resolveDataProvider(): IDataSourceVirtualDataProvider;
    protected propertyUpdatedOverride(a: string, b: any, c: any): void;
    private dh;
    private dv;
    private d1;
    protected resolveFullCount(a: number): number;
    private d0;
    private dz;
    private dg;
    private dx;
    protected get_isVirtual(): boolean;
    private cp;
    private cw;
    private cx;
    private cr;
    private b9;
    private cc;
    isPlaceholderItem(a: number): boolean;
    getItemAtIndex(a: number): any;
    private dl;
    private cd;
    private co;
    private cn;
    getItemPropertyAtIndex(a: number, b: string): any;
    private dm;
    private dy;
    private dw;
    addCandidate(a: number, b: DataSourcePageRequestPriority): boolean;
    removeCandidate(a: number): void;
    transformPage(a: number): number[];
    getUnrealizedCount(): number;
    onSetItemOverride(a: number, b: any, c: any): void;
    protected refreshInternalOverride(): void;
    private d2;
    onClearItemsOverride(): void;
    onInsertItemOverride(a: number, b: any): void;
    onRemoveItemOverride(a: number, b: any): void;
    protected get_isItemIndexLookupSupported(): boolean;
    protected get_isKeyIndexLookupSupported(): boolean;
    indexOfItem(a: any): number;
    private cu;
    indexOfKey(a: any[]): number;
    private cl;
    getStickyRowPriority(a: number): number;
    unpinRow(a: any[]): void;
    pinRow(a: any[]): void;
    isRowPinned(a: number): boolean;
    private ca;
    private c6;
    private cz;
    private c8;
    private c1;
    private c9;
    private c2;
    private c7;
    private c0;
    private db;
    private da;
    private c4;
    private c3;
    private c5;
    getStickyRowsInRange(a: number, b: number): number[];
    isExclusivelySticky(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    private cv;
    getIsRowExpandedAtIndex(a: number): boolean;
    setIsRowExpandedAtIndex(a: number, b: boolean): void;
    getRowLevel(a: number): number;
    getRootSummaryRowCount(): number;
    private dq;
    private dr;
    getRootSummaryResults(): ISummaryResult[];
    getSectionSummaryResults(a: number): ISummaryResult[];
}
